if Rails.env.development?
  fnull = File.constants.member?(:NULL) ? File.const_get(:NULL) : '/dev/null'
  Rails.application.assets.logger = Logger.new(fnull)
  Rails::Rack::Logger.class_eval do
    def call_with_quiet_assets(env)
      previous_level = Rails.logger.level
      Rails.logger.level = Logger::ERROR if env['PATH_INFO'] =~ %r{^/assets/}
      call_without_quiet_assets(env)
    ensure
      Rails.logger.level = previous_level
    end
    alias_method_chain :call, :quiet_assets
  end
end
