# encoding: UTF-8
# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 20131025183439) do

  create_table "dl_log_entries", force: true do |t|
    t.string   "ident"
    t.integer  "navi_voice_id"
    t.string   "ip_hash"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "dl_log_entries", ["navi_voice_id"], name: "index_dl_log_entries_on_navi_voice_id"

  create_table "navi_voices", force: true do |t|
    t.string   "title",                                   null: false
    t.float    "rating"
    t.text     "description",          default: "",       null: false
    t.string   "unit",                 default: "metric", null: false
    t.string   "lang",                 default: "ja",     null: false
    t.string   "author",               default: "",       null: false
    t.string   "delete_key",           default: "",       null: false
    t.boolean  "disabled",             default: false,    null: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "archive_file_name"
    t.string   "archive_content_type"
    t.integer  "archive_file_size"
    t.datetime "archive_updated_at"
    t.string   "archive_fingerprint"
    t.integer  "dlcount",              default: 0,        null: false
  end

  add_index "navi_voices", ["author"], name: "index_navi_voices_on_author"
  add_index "navi_voices", ["created_at", "disabled"], name: "index_navi_voices_on_created_at_and_disabled"
  add_index "navi_voices", ["dlcount"], name: "index_navi_voices_on_dlcount"
  add_index "navi_voices", ["rating", "disabled"], name: "index_navi_voices_on_rating_and_disabled"

  create_table "news", force: true do |t|
    t.string   "title",         default: "",    null: false
    t.text     "body"
    t.boolean  "skip_headline", default: false, null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "news", ["created_at"], name: "index_news_on_created_at"

  create_table "ratings", force: true do |t|
    t.string   "ident"
    t.integer  "navi_voice_id"
    t.integer  "value"
    t.string   "ip_hash"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "ratings", ["ident"], name: "index_ratings_on_ident"
  add_index "ratings", ["navi_voice_id"], name: "index_ratings_on_navi_voice_id"

end
